//------------------------------------------------------------
//  Project: Open Tools for Xbase++                          -
//  Repository : http://www.xbwin.com                        -
//  Author: Pablo Botella Navarro ( http://www.xbwin.com )   -
//------------------------------------------------------------
#include "ot4xb.ch"                                                                                   
// ---------------------------------------------------------------------------
proc main()
local oProcess := TRunProcess():New()
local lActive  := NIL
local dwExitCode

oProcess:cAppName := cPathCombine( GetWinDir(), "notepad.exe" )
// oProcess:cParams  := cPathCombine( cAppPath(), "TRunProcess.prg" )
// oProcess:lInheritHandles := .T.
oProcess:wShowWindow :=  oProcess:swMinimize
oProcess:lUseShowWindow := .T.
// oProcess:lCreateNewConsole := .F.
// oProcess:Cmd( "DIR > test.txt" )
if oProcess:Start()
   ? "Running " , oProcess:cAppName
   ? "Press ESC to KILL the process. SPACE to abandone"
   while !oProcess:Wait( 1000 ) // Wait 1 seconds
      inkey()
      if LastKey() == 27
         oProcess:Kill(-1)
         exit
      elseif LastKey() == 32
         exit
      end
   end
   dwExitCode := oProcess:GetExitCode(@lActive)
   if dwExitCode == NIL
      ? "Fail retrieving the process exit code"
   else
      ? "Exit Code: " , dwExitCode
      if lActive
         ?? " PROCESS IS STILL ACTIVE. ABANDONED"
      else
         ?? ". TERMINATED"
      end
   end
   oProcess:Release()
   // inkey(1)
   // while oProcess:lTestActiveById()
   //    inkey(1)
   //    if LastKey() == 27
   //       oProcess:KillById(-1)
   //       exit
   //    elseif LastKey() == 32
   //       exit
   //    end
   // end
   // ? "Exit Code: " , oProcess:GetExitCodeById()
else
   ? "Unable to run " , oProcess:cAppName
end
oProcess:Release()
inkey(0)
return
// ---------------------------------------------------------------------------


